"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const koishi_1 = require("koishi");
const database_1 = __importDefault(require("./internal/database"));
const command_1 = __importDefault(require("./internal/command"));
class HonkaiStarRail extends koishi_1.Service {
    constructor(app, config) {
        super(app, 'starrail', true);
        this.app = app;
        app.i18n.define('zh', require('./locales/zh'));
        // install the base command of first
        app.command('sr').action(async ({ session }) => session.execute('help sr'));
        // apply all internal plugins constructorer via mixin
        this.mixin([database_1.default, command_1.default]);
        // apply internal plugins.
        app.plugin(database_1.default);
        app.plugin(command_1.default, config);
    }
    mixin(constructorers) {
        constructorers.forEach((ctor) => {
            Object.getOwnPropertyNames(ctor.prototype).forEach((name) => {
                Object.defineProperty(HonkaiStarRail.prototype, name, Object.getOwnPropertyDescriptor(ctor.prototype, name) ||
                    Object.create(null));
            });
        });
    }
}
HonkaiStarRail.using = ['database'];
(function (HonkaiStarRail) {
    const BaseConfig = koishi_1.Schema.object({});
    HonkaiStarRail.Config = koishi_1.Schema.intersect([BaseConfig, command_1.default.Config]);
})(HonkaiStarRail || (HonkaiStarRail = {}));
__exportStar(require("./internal/database"), exports);
exports.default = HonkaiStarRail;
