import { Model } from "koishi";
import { Context, Field, Observed as OB } from "koishi";
declare module 'koishi' {
    interface User {
        sr_uid: string;
    }
    interface Binding {
        sr: number[];
    }
    interface Tables {
        star_rail: StarRail.Database;
    }
}
export declare namespace StarRail {
    type Field = keyof Database;
    const fields: Field[];
    type Observed<K extends Field = Field> = OB<Pick<Database, K>, Promise<void>>;
    interface Database {
        id: number;
        bid: number;
        uid: string;
        doken: string;
        cookie: string;
    }
}
declare class StarRailDatabase {
    private app;
    constructor(app: Context);
    getUid(bid: number): Promise<string[]>;
    existUid(uid: string): Promise<boolean>;
    setUid(bid: number, srUid: string, def?: boolean): Promise<void>;
    extendDatabase(fields: Field.Extension<StarRail.Database>, config?: Partial<Model.Config<StarRail.Database>>): void;
}
export default StarRailDatabase;
