"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StarRail = void 0;
var StarRail;
(function (StarRail) {
    StarRail.fields = [];
})(StarRail = exports.StarRail || (exports.StarRail = {}));
class StarRailDatabase {
    constructor(app) {
        this.app = app;
        app.model.extend('binding', {
            sr: 'list'
        });
        app.model.extend('user', {
            sr_uid: 'string(9)'
        });
        app.model.extend('star_rail', {
            id: 'unsigned',
            bid: 'integer',
            uid: 'string(9)',
            doken: 'string',
            cookie: 'text'
        }, {
            unique: ['id', 'uid'],
            autoInc: true,
            foreign: {
                id: ['user', 'id']
            }
        });
        app.on('ready', () => {
        });
    }
    async getUid(bid) {
        return (await this.app.database.get('star_rail', { bid }, ["uid"])).map(u => u.uid);
    }
    async existUid(uid) {
        return (await this.app.database.get('star_rail', { uid })).length > 0;
    }
    async setUid(bid, srUid, def = false) {
        if (def === true)
            await this.app.database.set('user', { id: bid }, { sr_uid: srUid });
        await this.app.database.upsert('star_rail', [{ bid, uid: srUid }], ['uid']);
    }
    extendDatabase(fields, config) {
        this.app.model.extend('star_rail', fields, config);
    }
}
exports.default = StarRailDatabase;
